#include <Engine/types/entity/InstancedSprite.h>
#include <Engine/Globals.h>

using namespace Engine;
Texture* InstancedSprite::GetTexture() {
    auto* itx = GetScene()->GetInstancedTexture(this);
    if (itx)
        return itx->GetTexture();
    return nullptr;
}

Texture* InstancedSprite::GetAlphaMask() {
    auto* ita = GetScene()->GetInstancedAlphaMask(this);
    if (ita)
        return ita->GetTexture();
    return Sprite::GetAlphaMask();
}

InstancedSprite::~InstancedSprite() {
    auto* itx = GetScene()->GetInstancedTexture(this);
    if (itx) {
        itx->RemoveUser(this);
        if (itx->ReferenceCount() == 0)
            GetScene()->DestroyInstancedTexture(itx);
    }

    auto* ita = GetScene()->GetInstancedAlphaMask(this);
    if (ita) {
        ita->RemoveUser(this);
        if (ita->ReferenceCount() == 0)
            GetScene()->DestroyInstancedAlphaMask(ita);
    }
}
